/*
  Enrique Jos Garca Gonzlez           alu2627
  Implementacin de pilas
*/

#include <stdio.h>
#include <stdlib.h>
#include "memoria.h"
#include "pila.h"

/*------------------------------------------------------*/
/* Devuelve 1 si esta vaca o 0 si no lo est */

int pila_vacia (nodo *top) {

   if (top == NULL)
      return (1);
   else
      return (0);
}

/*------------------------------------------------------*/
/* Crea un nodo con la informacin facilitada. Devuelve el nodo creado. */

nodo *crear_nodo (tipodato x) {
   nodo *nuevo;

   nuevo = (nodo *) ck_malloc (sizeof (nodo));
   nuevo->info = x;
   nuevo->sig = NULL;
   return (nuevo);
}

/*------------------------------------------------------*/
/* Insercin del nodo insertar en la pila top. Devuelve el nuevo top */

/*nodo *push (nodo *top, tipodato x) { */
void push (nodo **top, tipodato x) {
   nodo *a_insertar;

   a_insertar = crear_nodo (x);
   a_insertar->sig = *top;
   *top = a_insertar;
}

/*------------------------------------------------------*/
/* Saca un elemento de la pila y lo elimina. Devuelve el nuevo top */

/* tipodato pop (pila *top) { */
void pop (nodo **top) {
   nodo *aux;
   tipodato dato;

   aux = *top;
   *top = (*top)->sig;
   dato = aux->info;
   free (aux);
}
/*------------------------------------------------------*/
/* Copia la pila recibida y la devuelve la propia funcin */
nodo *copiar_pila (nodo *top) {
   nodo *aux, *nuevo_top = NULL;

   if (top != NULL) {
      nuevo_top = crear_nodo (top->info);
      top = top->sig;
   }
   aux = nuevo_top;
   while (top != NULL) {
      aux->sig = crear_nodo (top->info);
      aux = aux->sig;
      top = top->sig;
   }
   return (nuevo_top);
}
/*------------------------------------------------------*/
/* Libera los nodos de la pila */
pila free_pila (pila top) {
   while (top != NULL)
      pop (&top);
   return (top);
}
/*------------------------------------------------------*/
/* muestra el contenido de la pila */
void mostrar_pila (pila top) {
   pila aux;
   aux = top;
   printf ("TOP ");
   while (aux != NULL) {
      printf ("%c", aux->info);
      aux = aux->sig;
   }
}

